;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;       NAME: template.asm
;
;      Generic driver for xc16x-16F TC1
;
;       (c) Copyright 2014. Infineon AG
;       Christian Perschl
;       Release 0.1
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

$SEGMENTED                                      ; Segemented memory mode
$CASE                                           ; Symbols case sensitive

;define your functions if different functions are required
FC_01			EQU	001h	; Function code 1
FC_02			EQU 002h	; Function code 2

        NAME            MINIMON
OPBANK  REGDEF          R0-R15 private
        ASSUME          DPP3:system

StackData0              SECTION DATA SYSSTACK           ; Data Section to reserve 
                                                ; Stack-Memory  
               DSB      20H                             ; 32 Byte 

StackData0              ENDS                            ; End of Dummy-Section


DriverCode0             SECTION CODE PUBLIC 'CDRIVER'
DriverProc              PROC FAR


Init: ; Do some initialization if required

Cmd1:	
	CMP	R8,#(FC_01)
	JMPR	cc_NE,Cmd2

	; Add here your code for Function 01   
	; Function 01: Bitcount
	; R8=0001
	; R9=Number of bytes
	; R10=Start Address A0-A15
	; R11=Start Address A16-A23
    ; Return Parameter
	; R15 contains number of ones in Hex
	
	;internal register variables
    ;R7 contains segment
	;R12 contains current data word
	;R13 contains bit within word 
	
	; initialize bit counter
	MOV R15,#0000h
	;initialize segment
	MOV R7,R11
	
Readout:
	; read in data
	EXTS R7,#0001
	MOV R12,[R10]
	MOV R13,#0016
Count:
    JB  R12.0,ItsAOne
	JMP GoAhead

ItsAOne:
	ADD R15,#0001    	
GoAhead:	
	SHR R12,#0001
	CMP R12,#0000
	JMP cc_NE,Count
NextWord:
	ADD	R10,#0002
	CMPD2 R9,#0002
	JMP	cc_NE,Readout
	
	MOV R12,#00FC80h
	MOV R13,#0000h
	EXTS R13,#1
	MOV [R12],R15
	RETS

Cmd2:	
	CMP	R8,#(FC_02)
	JMPR	cc_NE,Cmd3

	; Add here your code for Function 02                 

	RETS

Cmd3: ; No further Function
	RETS

       RETV                     ; RET virtual 


DriverProc                      ENDP

DriverCode0                     ENDS

                                END
