;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;       NAME: marginsweep.asm
;
;      Generic driver for xc16x-16F TC1
;
;       (c) Copyright 2014. Infineon AG
;       Christian Perschl
;       Release 0.1
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

$SEGMENTED                                      ; Segemented memory mode
$CASE                                           ; Symbols case sensitive


        NAME            MINIMON
OPBANK  REGDEF          R0-R15 private
        ASSUME          DPP3:system

StackData0              SECTION DATA SYSSTACK           ; Data Section to reserve 
                                                ; Stack-Memory  
               DSB      20H                             ; 32 Byte 

StackData0              ENDS                            ; End of Dummy-Section


DriverCode0             SECTION CODE PUBLIC 'CDRIVER'
DriverProc              PROC FAR


	; R10=Start Address A0-A15
	; R11=Start Address A16-A23
	; R12=Target Address A0-A15
	; R13=Target Address A16-A23
	
    ; Return Parameter
	; none

	;internal register variables
	;R7 target pointer
	;R6 margin
	;R5 data word
	
Initialize:
	; initialize target area
	MOV R15,#16 ; 16 words target
	MOV R7,R12
	MOV R6,#0000h ; start margin

ILoop:
    EXTS R13,#1
	MOV  [R7],R6
    ADD  R7,#2	
	CMPD1 R15,#1
	JMP cc_NE,ILoop

SetMargin: 	
	MOV  R15,#0F00Eh
    EXTS #0FFh,#01
	MOV  [R15],R6

	MOV  R14,#256
DummyRead:
	EXTS R11,#1
	MOV  R5,[R10]
	ADD  R10,#2
	CMPD2 R14,#2
	JMP  cc_NE,DummyRead
	SUB  R10,#256
	
Readout:
    ; reset target pointer
	MOV  R7,R12
	; read in data word
	EXTS R11,#0001
	MOV R5,[R10]
	;reset bit counter
	MOV R14,#0016

Count:
	; JMP WriteMarginToTargetBuffer ; write margin
    JB  R5.0,ItsAOne
	JMP GoAhead
	
ItsAOne:
    ; check if target / margin not olready set
    EXTS R13,#0001
	MOV R15,[R7]
	CMP R15,#0000
	JMP cc_NE,GoAhead ;already written

WriteMarginToTargetBuffer:	
	; write margin into target memory
    EXTS R13,#0001
    MOV [R7],R6
	
GoAhead:
    ADD  R7,#02 ; next target word address
	SHR R5,#0001 ;next bit
	CMPD1 R14,#0001
	JMP cc_NE,Count
	
NextMargin:
	ADD R6,#0004 ;increment margin by 4
	CMP R6,#0040h
	JMP cc_NE,SetMargin

	RETS


       RETV                     ; RET virtual 


DriverProc                      ENDP

DriverCode0                     ENDS

                                END
